#ifndef ZSPIDERWIDGET
#define ZSPIDERWIDGET

#include <QtGui>
#include <QWidget>

class QObject;
class QLabel;
class QLineEdit;
class QPainter;
class QPainterPath;

class ZSpiderWidget : public QWidget
{
  Q_OBJECT  

  public:
    ZSpiderWidget(QStringList playersList, QWidget *parent = 0);

    bool matchesDone();
    int position();
    void setPosition(int pos);
    QStringList results();
    void setResults(QStringList list);
    void spiderUpdateAll();
    void spiderUpdate(int num);

  public slots:

  signals:
    void matchDone(int firstPosition, QMap<int, QString> playersOrderFinal);
    void windowModified(bool modified);

  protected:
    void paintEvent(QPaintEvent *event);

  private slots:
  void editingFinished();

  private:
    void setMatchesDone(bool done);

    QLabel *lblOrder;
    QVector<QLineEdit *> ledMatchSet;

    QFont font;

    int rows;
    int textWidth;
    int firstPosition;
    int rowsOffset;
    int numberOfPlayers;
    int countPerSide;
    bool _matchesDone;
    QString playersOrder;
    QStringList playersGamingOrder;
    QMap<int, QString> playersOrderFinal;
    QMap<int, QVector<double> > rowSequence;
};
#endif
