#ifndef DELEGATE_H
#define DELEGATE_H

#include <QObject>
#include <QItemDelegate>
#include <QModelIndex>
#include <QSize>
#include <QStyledItemDelegate>
#include <QStyleOptionViewItem>
#include <QMap>

class QTableView;
class QStandardItem;
class QStandardItemModel;
class QAbstractItemView;


class ZTeamMatchesDelegate : public QItemDelegate
{
    Q_OBJECT

public:
    ZTeamMatchesDelegate(QObject *parent = 0, int team = 0);

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                          const QModelIndex &index) const;

    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const;
    QSize sizeHint(const QStyleOptionViewItem &option,
                   const QModelIndex &index) const;
        
private slots:
    void okClicked();
    void addClicked();
    void itemChange(QStandardItem *item);

private:
  void adjustContentSize() const;

  int team;

};

#endif
